//
//  DXAspectControllerBasic.h
//  DiceX
//
//  Created by Andrew Merenbach on 6/23/07.
//  Copyright 2007 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DXAspectController.h"

extern NSString *AMCountOfDiceKey;
extern NSString *AMSidesPerDieKey;
extern NSString *AMWillRollAsPercentileKey;
extern NSString *AMValueForPercentileEqualsMaxKey;


@interface DXAspectControllerBasic : DXAspectController {
@private

	IBOutlet NSComboBox *countOfDiceComboBox;
	IBOutlet NSComboBox *sidesPerDieComboBox;
	IBOutlet NSTextField *percentileMaxTextField;
	
	//IBOutlet NSButton *rollAsPercentileCB;
	//IBOutlet NSButton *percentileZeroEqualsMaxCB;
	
	int AM_countOfDice;
	int AM_sidesPerDie;
	
	BOOL AM_rollAsPercentile;
	BOOL AM_percentileZeroEqualsMax;
	
	unsigned int AM_valueForPercentileZeroEqualsMax;
}

- (void)modifiedPercentileRoll:(id)sender;
- (void)updateZeroMaxTextField;

@end

@interface DXAspectControllerBasic (Accessors)

- (int)countOfDice;
- (void)setCountOfDice:(int)anInt;

- (int)sidesPerDie;
- (void)setSidesPerDie:(int)anInt;

- (BOOL)willRollAsPercentile;
- (void)setWillRollAsPercentile:(BOOL)flag;

- (BOOL)percentileZeroEqualsMax;
- (void)setPercentileZeroEqualsMax:(BOOL)flag;

- (unsigned int)valueForPercentileZeroEqualsMax;
- (void)setValueForPercentileZeroEqualsMax:(unsigned int)anInt;

@end
