//
//  DXAspectControllerDrops.h
//  DiceX
//
//  Created by Andrew Merenbach on 6/23/07.
//  Copyright 2007 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DXAspectController.h"

extern NSString *AMWillDropLowestValueKey;
extern NSString *AMWillDropHighestValueKey;
extern NSString *AMLowestDropValueKey;
extern NSString *AMHighestDropValueKey;


@interface DXAspectControllerDrops : DXAspectController {
@private

	BOOL AM_willDropLowestValue;
	BOOL AM_willDropHighestValue;
	
	int AM_lowestDropValue;
	int AM_highestDropValue;
	
	BOOL AM_willRollAsPercentile;
}

@end

@interface DXAspectControllerDrops (DropsAccessors)

- (BOOL)willDropLowestValue;
- (void)setWillDropLowestValue:(BOOL)flag;
- (BOOL)willDropHighestValue;
- (void)setWillDropHighestValue:(BOOL)flag;

- (int)lowestDropValue;
- (void)setLowestDropValue:(int)anInt;
- (int)highestDropValue;
- (void)setHighestDropValue:(int)anInt;

@end

@interface DXAspectControllerDrops (PercentileDiceExtensions)

- (BOOL)willRollAsPercentile;
- (void)setWillRollAsPercentile:(BOOL)flag;

@end
