//
//  DXAspectControllerMain.h
//  DiceX
//
//  Created by Andrew Merenbach on 6/23/07.
//  Copyright 2007 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DXAspectController.h"

extern NSString *AMLogRollsKey;
extern NSString *AMAutoscrollLogEntriesKey;
extern NSString *AMAutoExpandLogEntriesKey;
extern NSString *AMRollRepetitionsKey;

@class DXDieGroup;


@interface DXAspectControllerMain : DXAspectController {
@private
	//int AM_result;
	
	BOOL AM_logRolls;
	BOOL AM_autoscrollLogEntries;
	BOOL AM_autoExpandLogEntries;

	unsigned int AM_rollRepetitions;
	
	IBOutlet NSArrayController *rollArrayController;
	
	unsigned int masterOrderHint;
	NSArray *AM_resultSortDescriptors;
	
	NSManagedObjectContext *mainManagedObjectContext;
	
	NSPersistentStoreCoordinator *AM_psCoordinator;
	
	BOOL AM_processingRolls;
	BOOL AM_saving;
	
	NSString *AM_titleForRollButton;
}

// rolling is in first responder, and thus our NSApp delegate can handle it
//- (void)roll:(id)sender;

- (void)clearRolls;
- (void)addRolls:(NSArray *)rolls;
- (void)finishAddingRolls;
//- (BOOL)fetchRollEntries;
//- (void)finishAddingRoll;

@end

@interface DXAspectControllerMain (Accessors)

- (BOOL)isSaving;
- (void)setSaving:(BOOL)flag;

- (BOOL)isProcessingRolls;
- (void)setProcessingRolls:(BOOL)flag;

//- (int)result;
//- (void)setResult:(int)anInt;

- (BOOL)logRolls;
- (void)setLogRolls:(BOOL)flag;

- (BOOL)autoscrollLogEntries;
- (void)setAutoscrollLogEntries:(BOOL)flag;

- (BOOL)autoExpandLogEntries;
- (void)setAutoExpandLogEntries:(BOOL)flag;

- (int)rollRepetitions;
- (void)setRollRepetitions:(int)anInt;

/*- (unsigned int)numberOfNewEntries;
- (void)setNumberOfNewEntries:(unsigned int)anInt;*/

- (NSArray *)resultSortDescriptors;
- (void)setResultSortDescriptors:(NSArray *)anArray;

- (NSPersistentStoreCoordinator *)persistentStoreCoordinatorRef;
- (void)setPersistentStoreCoordinatorRef:(NSPersistentStoreCoordinator *)coordinator;

- (NSString *)titleForRollButton;
- (void)setTitleForRollButton:(NSString *)aString;

@end