//
//  DXAspectControllerModifiers.h
//  DiceX
//
//  Created by Andrew Merenbach on 6/23/07.
//  Copyright 2007 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DXAspectController.h"

extern NSString *AMWillApplyPerDieBonusValueKey;
extern NSString *AMWillApplyPerDiePenaltyValueKey;
extern NSString *AMWillApplyPerDieMultiplierValueKey;

extern NSString *AMWillApplyToTotalBonusValueKey;
extern NSString *AMWillApplyToTotalPenaltyValueKey;
extern NSString *AMWillApplyToTotalMultiplierValueKey;

extern NSString *AMPerDieBonusValueKey;
extern NSString *AMPerDiePenaltyValueKey;
extern NSString *AMPerDieMultiplierValueKey;

extern NSString *AMToTotalBonusValueKey;
extern NSString *AMToTotalPenaltyValueKey;
extern NSString *AMToTotalMultiplierValueKey;


@interface DXAspectControllerModifiers : DXAspectController {
@private

	BOOL AM_willApplyPerDieBonusValue;
	BOOL AM_willApplyPerDiePenaltyValue;
	BOOL AM_willApplyPerDieMultiplierValue;
	
	BOOL AM_willApplyToTotalBonusValue;
	BOOL AM_willApplyToTotalPenaltyValue;
	BOOL AM_willApplyToTotalMultiplierValue;
	
	int AM_perDieBonusValue;
	int AM_toTotalBonusValue;
	int AM_perDiePenaltyValue;
	int AM_toTotalPenaltyValue;
	int AM_perDieMultiplierValue;
	int AM_toTotalMultiplierValue;

	BOOL AM_willRollAsPercentile;
}

- (void)percentileRollApplyChanges:(NSNotification *)aNotification;

@end

@interface DXAspectControllerModifiers (InputAccessors)

- (BOOL)willApplyPerDieBonusValue;
- (void)setWillApplyPerDieBonusValue:(BOOL)flag;
- (BOOL)willApplyPerDiePenaltyValue;
- (void)setWillApplyPerDiePenaltyValue:(BOOL)flag;
- (BOOL)willApplyPerDieMultiplierValue;
- (void)setWillApplyPerDieMultiplierValue:(BOOL)flag;

- (BOOL)willApplyToTotalBonusValue;
- (void)setWillApplyToTotalBonusValue:(BOOL)flag;
- (BOOL)willApplyToTotalPenaltyValue;
- (void)setWillApplyToTotalPenaltyValue:(BOOL)flag;
- (BOOL)willApplyToTotalMultiplierValue;
- (void)setWillApplyToTotalMultiplierValue:(BOOL)flag;

- (int)perDieBonusValue;
- (void)setPerDieBonusValue:(int)anInt;
- (int)perDiePenaltyValue;
- (void)setPerDiePenaltyValue:(int)anInt;
- (int)perDieMultiplierValue;
- (void)setPerDieMultiplierValue:(int)anInt;

- (int)toTotalBonusValue;
- (void)setToTotalBonusValue:(int)anInt;
- (int)toTotalPenaltyValue;
- (void)setToTotalPenaltyValue:(int)anInt;
- (int)toTotalMultiplierValue;
- (void)setToTotalMultiplierValue:(int)anInt;

@end

@interface DXAspectControllerModifiers (PercentileDiceExtensions)

- (BOOL)willRollAsPercentile;
- (void)setWillRollAsPercentile:(BOOL)flag;

@end
