//
//  DXDie.h
//  DiceX
//
//  Created by Andrew Merenbach on 25/11/2004.
//  Copyright 2004 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface DXDie : NSObject {	//<NSCoding>
@private
	unsigned int AM_numberOfSides;
	BOOL AM_included;

	unsigned int AM_rollValue;
	int AM_total;
	double AM_diePercentage;
	
	unsigned int AM_dieBonusModifier;
	unsigned int AM_diePenaltyModifier;
	unsigned int AM_dieMultiplierModifier;
	
	NSNumber *AM_numberForRollValue;
}

- (id)init;
- (void)dealloc;

- (void)updateNumberForRollValue;

- (void)rollDie;
- (void)rollDieForPercentile;

- (void)drop;

- (NSComparisonResult)compare:(DXDie *)otherDie;


@end

@interface DXDie (Accessors)

- (unsigned int)numberOfSides;
- (void)setNumberOfSides:(unsigned int)anInt;
- (unsigned int)dieBonusModifier;
- (void)setDieBonusModifier:(unsigned int)anInt;
- (unsigned int)diePenaltyModifier;
- (void)setDiePenaltyModifier:(unsigned int)anInt;
- (unsigned int)dieMultiplierModifier;
- (void)setDieMultiplierModifier:(unsigned int)anInt;

- (double)diePercentage;
- (void)setDiePercentage:(double)aDouble;

- (BOOL)isIncluded;
- (void)setIncluded:(BOOL)flag;

- (NSNumber *)numberForRollValue;
- (void)setNumberForRollValue:(NSNumber *)aNumber;

@end


@interface DXDie (DXNodeCompatibilityCrossover)

- (unsigned)rollValue;
- (void)setRollValue:(unsigned int)anInt;

- (int)total;
- (void)setTotal:(int)anInt;

- (void)recalculateTotal;
//- (void)recalculateTotalWithBonus:(unsigned int)bonus andPenalty:(unsigned int)penalty;

@end