//
//  DXDie.m
//  DiceX
//
//  Created by Andrew Merenbach on 25/11/2004.
//  Copyright 2004 Andrew Merenbach. All rights reserved.
//

#import "DXDie.h"


@implementation DXDie

- (id)init {
	if (self = [super init]) {
		AM_numberOfSides = 0;
		AM_included = YES;
		
		AM_dieBonusModifier = 0;
		AM_diePenaltyModifier = 0;
		AM_dieMultiplierModifier = 1;
		
		AM_rollValue = 0;
		AM_total = 0;
		AM_diePercentage = 0.0f;
		
		AM_numberForRollValue = [[NSNumber alloc] initWithInt:0];
	}
	return self;
}

- (void)dealloc {
	[AM_numberForRollValue release];
	AM_numberForRollValue = nil;
	
	[super dealloc];
}

- (void)rollDie {
	[self setRollValue:((random()%[self numberOfSides]) + 1)];
}

- (void)rollDieForPercentile {
	[self setRollValue:(random()%[self numberOfSides])];
}

// -----------------

- (void)updateNumberForRollValue {
	//int rollValue = [self isIncluded] ? [self rollValue] : 0;
	int rollValue = [self rollValue];
	NSNumber *num = [[NSNumber alloc] initWithInt:rollValue];
	[self setNumberForRollValue:num];
	[num release];
}


/* method to drop a die */
- (void)drop {
	[self setIncluded:NO];
}

- (NSComparisonResult)compare:(DXDie *)otherDie {
	return [[self numberForRollValue] compare:[otherDie numberForRollValue]];
}

@end



@implementation DXDie (Accessors)

- (unsigned int)numberOfSides {
	return AM_numberOfSides;
}

- (void)setNumberOfSides:(unsigned int)anInt {
	AM_numberOfSides = anInt;
}

- (unsigned int)dieBonusModifier {
	return AM_dieBonusModifier;
}

- (void)setDieBonusModifier:(unsigned int)anInt {
	AM_dieBonusModifier = anInt;
}

- (unsigned int)diePenaltyModifier {
	return AM_diePenaltyModifier;
}

- (void)setDiePenaltyModifier:(unsigned int)anInt {
	AM_diePenaltyModifier = anInt;
}

- (unsigned int)dieMultiplierModifier {
	return AM_dieMultiplierModifier;
}

- (void)setDieMultiplierModifier:(unsigned int)anInt {
	AM_dieMultiplierModifier = anInt;
}

- (double)diePercentage {
	return AM_diePercentage;
}

- (void)setDiePercentage:(double)aDouble {
	AM_diePercentage = aDouble;
}

- (BOOL)isIncluded {
	return AM_included;
}

- (void)setIncluded:(BOOL)flag {
	AM_included = flag;
}

- (NSNumber *)numberForRollValue {
	return [[AM_numberForRollValue retain] autorelease];
}

- (void)setNumberForRollValue:(NSNumber *)aNumber {
	if (aNumber != AM_numberForRollValue) {
		[AM_numberForRollValue release];
		AM_numberForRollValue = [aNumber retain];
	}
}

@end

@implementation DXDie (DXNodeCompatibilityCrossover)

- (unsigned int)rollValue {
	return AM_rollValue;
}

- (void)setRollValue:(unsigned int)anInt {
	if (anInt != AM_rollValue) {
		AM_rollValue = anInt;
		
		[self updateNumberForRollValue];
		//[self recalculateTotal];
	}
}

- (int)total {
	return AM_total;
}

- (void)setTotal:(int)anInt {
	AM_total = anInt;
}

- (void)recalculateTotal {
	int newTotal = [self rollValue];
	newTotal += [self dieBonusModifier];
	newTotal -= [self diePenaltyModifier];
	newTotal *= [self dieMultiplierModifier];
	
	[self setTotal:newTotal];
}

@end
