//
//  DXDieGroup.h
//  DiceX
//
//  Created by Andrew Merenbach on 25/11/2004.
//  Copyright 2004 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface DXDieGroup : NSObject {	//<NSCoding>
@private
	NSMutableArray *diceArray;
	
	unsigned AM_dieCount;
	unsigned AM_sidesPerDie;
	int AM_bonusModifier;
	double AM_percentage;
	
	int AM_total;
	
	unsigned int AM_perDieBonusModifier;
	unsigned int AM_perDiePenaltyModifier;
	unsigned int AM_perDieMultiplierModifier;
	
	unsigned int AM_totalBonusModifier;
	unsigned int AM_totalPenaltyModifier;
	unsigned int AM_totalMultiplierModifier;
	
	BOOL AM_percentileRoll;
}

+ (void)initialize;

- (id)init;
- (void)dealloc;

- (NSEnumerator *)dieEnumerator;

- (void)rollDice;
- (void)rollDiceForPercentile;
- (void)tallyDice;
- (void)tallyDiceForPercentileRoll:(BOOL)willPercentileZeroEqualMax;
- (void)sortDice;

- (void)rerollPercentileDiceWithValuesUnder:(int)testValue withMods:(BOOL)mods;
- (void)rerollPercentileDiceWithValuesOver:(int)testValue withMods:(BOOL)mods;

- (NSMutableArray *)blankDice;
//- (void)rollDice;

- (void)dropLowRollsWithCount:(unsigned int)rollDrops;
- (void)dropHighRollsWithCount:(unsigned int)rollDrops;

//- (NSEnumerator *)dieEnumerator;

//- (NSString *)rollString;
//- (NSString *)dropsString;

//- (void)recalculateTotal;

@end

@interface DXDieGroup (Accessors)

- (int)total;
- (void)setTotal:(int)anInt;

- (unsigned)dieCount;
- (void)setDieCount:(unsigned)aNumber;
- (unsigned)sidesPerDie;
- (void)setSidesPerDie:(unsigned)aNumber;

- (unsigned int)perDieBonusModifier;
- (void)setPerDieBonusModifier:(unsigned int)anInt;
- (unsigned int)perDiePenaltyModifier;
- (void)setPerDiePenaltyModifier:(unsigned int)anInt;
- (unsigned int)perDieMultiplierModifier;
- (void)setPerDieMultiplierModifier:(unsigned int)anInt;

/* these may be equal to zero at some point; this is expected */
- (unsigned int)totalBonusModifier;
- (void)setTotalBonusModifier:(unsigned int)anInt;
- (unsigned int)totalPenaltyModifier;
- (void)setTotalPenaltyModifier:(unsigned int)anInt;
- (unsigned int)totalMultiplierModifier;
- (void)setTotalMultiplierModifier:(unsigned int)anInt;

- (double)percentage;
- (void)setPercentage:(double)aDouble;

- (BOOL)isPercentileRoll;
- (void)setIsPercentileRoll:(BOOL)flag;

@end
