// 
//  DXDieNode.m
//  DiceX
//
//  Created by Andrew Merenbach on 30/12/06.
//  Copyright 2006 Andrew Merenbach. All rights reserved.
//

#import "DXDieNode.h"


@implementation DXDieNode 

- (NSNumber *)bonusModifier 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"bonusModifier"];
    tmpValue = [self primitiveValueForKey: @"bonusModifier"];
    [self didAccessValueForKey: @"bonusModifier"];
    
    return tmpValue;
}

- (void)setBonusModifier:(NSNumber *)value 
{
    [self willChangeValueForKey: @"bonusModifier"];
    [self setPrimitiveValue: value forKey: @"bonusModifier"];
    [self didChangeValueForKey: @"bonusModifier"];
}

- (NSNumber *)penaltyModifier 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"penaltyModifier"];
    tmpValue = [self primitiveValueForKey: @"penaltyModifier"];
    [self didAccessValueForKey: @"penaltyModifier"];
    
    return tmpValue;
}

- (void)setPenaltyModifier:(NSNumber *)value 
{
    [self willChangeValueForKey: @"penaltyModifier"];
    [self setPrimitiveValue: value forKey: @"penaltyModifier"];
    [self didChangeValueForKey: @"penaltyModifier"];
}

- (NSNumber *)multiplierModifier 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"multiplierModifier"];
    tmpValue = [self primitiveValueForKey: @"multiplierModifier"];
    [self didAccessValueForKey: @"multiplierModifier"];
    
    return tmpValue;
}

- (void)setMultiplierModifier:(NSNumber *)value 
{
    [self willChangeValueForKey: @"multiplierModifier"];
    [self setPrimitiveValue: value forKey: @"multiplierModifier"];
    [self didChangeValueForKey: @"multiplierModifier"];
}

- (NSNumber *)numberOfDicePerRoll 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"numberOfDicePerRoll"];
    tmpValue = [self primitiveValueForKey: @"numberOfDicePerRoll"];
    [self didAccessValueForKey: @"numberOfDicePerRoll"];
    
    return tmpValue;
}

- (void)setNumberOfDicePerRoll:(NSNumber *)value 
{
    [self willChangeValueForKey: @"numberOfDicePerRoll"];
    [self setPrimitiveValue: value forKey: @"numberOfDicePerRoll"];
    [self didChangeValueForKey: @"numberOfDicePerRoll"];
}

- (NSString *)rollValue 
{
    NSString * tmpValue;
    
    [self willAccessValueForKey: @"rollValue"];
    tmpValue = [self primitiveValueForKey: @"rollValue"];
    [self didAccessValueForKey: @"rollValue"];
    
    return tmpValue;
}

- (void)setRollValue:(NSString *)value 
{
    [self willChangeValueForKey: @"rollValue"];
    [self setPrimitiveValue: value forKey: @"rollValue"];
    [self didChangeValueForKey: @"rollValue"];
}

- (NSNumber *)numberOfSidesPerDie 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"numberOfSidesPerDie"];
    tmpValue = [self primitiveValueForKey: @"numberOfSidesPerDie"];
    [self didAccessValueForKey: @"numberOfSidesPerDie"];
    
    return tmpValue;
}

- (void)setNumberOfSidesPerDie:(NSNumber *)value 
{
    [self willChangeValueForKey: @"numberOfSidesPerDie"];
    [self setPrimitiveValue: value forKey: @"numberOfSidesPerDie"];
    [self didChangeValueForKey: @"numberOfSidesPerDie"];
}

- (NSNumber *)total 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"total"];
    tmpValue = [self primitiveValueForKey: @"total"];
    [self didAccessValueForKey: @"total"];
    
    return tmpValue;
}

- (void)setTotal:(NSNumber *)value 
{
    [self willChangeValueForKey: @"total"];
    [self setPrimitiveValue: value forKey: @"total"];
    [self didChangeValueForKey: @"total"];
}

- (NSNumber *)percentage 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"percentage"];
    tmpValue = [self primitiveValueForKey: @"percentage"];
    [self didAccessValueForKey: @"percentage"];
    
    return tmpValue;
}

- (void)setPercentage:(NSNumber *)value 
{
    [self willChangeValueForKey: @"percentage"];
    [self setPrimitiveValue: value forKey: @"percentage"];
    [self didChangeValueForKey: @"percentage"];
}

- (NSNumber *)isPercentileRoll 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"isPercentileRoll"];
    tmpValue = [self primitiveValueForKey: @"isPercentileRoll"];
    [self didAccessValueForKey: @"isPercentileRoll"];
    
    return tmpValue;
}

- (void)setIsPercentileRoll:(NSNumber *)value 
{
    [self willChangeValueForKey: @"isPercentileRoll"];
    [self setPrimitiveValue: value forKey: @"isPercentileRoll"];
    [self didChangeValueForKey: @"isPercentileRoll"];
}

- (NSNumber *)isIncluded 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"isIncluded"];
    tmpValue = [self primitiveValueForKey: @"isIncluded"];
    [self didAccessValueForKey: @"isIncluded"];
    
    return tmpValue;
}

- (void)setIsIncluded:(NSNumber *)value 
{
    [self willChangeValueForKey: @"isIncluded"];
    [self setPrimitiveValue: value forKey: @"isIncluded"];
    [self didChangeValueForKey: @"isIncluded"];
}

- (NSNumber *)orderHint 
{
    NSNumber * tmpValue;
    
    [self willAccessValueForKey: @"orderHint"];
    tmpValue = [self primitiveValueForKey: @"orderHint"];
    [self didAccessValueForKey: @"orderHint"];
    
    return tmpValue;
}

- (void)setOrderHint:(NSNumber *)value 
{
    [self willChangeValueForKey: @"orderHint"];
    [self setPrimitiveValue: value forKey: @"orderHint"];
    [self didChangeValueForKey: @"orderHint"];
}

- (void)addChildrenObject:(DXDieNode *)value 
{    
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"children" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"children"] addObject: value];
    
    [self didChangeValueForKey:@"children" withSetMutation:NSKeyValueUnionSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}

- (void)removeChildrenObject:(DXDieNode *)value 
{
    NSSet *changedObjects = [[NSSet alloc] initWithObjects:&value count:1];
    
    [self willChangeValueForKey:@"children" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [[self primitiveValueForKey: @"children"] removeObject: value];
    
    [self didChangeValueForKey:@"children" withSetMutation:NSKeyValueMinusSetMutation usingObjects:changedObjects];
    
    [changedObjects release];
}


- (DXDieNode *)parent 
{
    id tmpObject;
    
    [self willAccessValueForKey: @"parent"];
    tmpObject = [self primitiveValueForKey: @"parent"];
    [self didAccessValueForKey: @"parent"];
    
    return tmpObject;
}

- (void)setParent:(DXDieNode *)value 
{
    [self willChangeValueForKey: @"parent"];
    [self setPrimitiveValue: value
                     forKey: @"parent"];
    [self didChangeValueForKey: @"parent"];
}


@end
