//
//  DXLogWindowController+EntryManagement.h
//  DiceX
//
//  Created by Andrew Merenbach on 8/1/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "DXLogWindowController.h"


@interface DXLogWindowController (ExpandAndCollapseAndScroll)

- (BOOL)canCollapseOrExpandLogEntries;

- (void)expandMostRecentEntry:(id)sender;
- (void)scrollMostRecentEntryToVisible:(id)sender;

- (void)expandFirstEntry:(id)sender;	// cover method for log outline view
- (void)expandLastEntry:(id)sender;		// cover method for log outline view

- (void)collapseAllEntries:(id)sender;
//- (void)collapseAllEntriesThread:(id)sender;
- (void)expandAllEntries:(id)sender;
//- (void)expandAllEntriesThread:(id)sender;

- (BOOL)autoscrollEntries;
- (void)setAutoscrollEntries:(BOOL)flag;
- (BOOL)autoExpandEntries;
- (void)setAutoExpandEntries:(BOOL)flag;

@end

@interface DXLogWindowController (EntryRemoval)

- (BOOL)canRemoveLogEntry;
- (BOOL)canClearLogEntries;

- (IBAction)clearLog:(id)sender;
- (void)clearSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode;	// contextInfo:(void *)contextInfo
//- (void)clearAllRollsThread;

- (void)removeSelectedEntries:(id)sender;
//- (void)removeSelectedEntriesThread:(id)sender;

@end


@interface DXLogWindowController (OutlineViewDataSource)

- (void)delete:(id)sender;

- (id)outlineView:(NSOutlineView *)outlineView child:(int)index ofItem:(id)item;
- (BOOL)outlineView:(NSOutlineView *)outlineView isItemExpandable:(id)item;
- (int)outlineView:(NSOutlineView *)outlineView numberOfChildrenOfItem:(id)item;
- (id)outlineView:(NSOutlineView *)outlineView objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item;

@end
