//
//  DXLogWindowController.h
//  DiceX
//
//  Created by Andrew Merenbach on 22/11/2004.
//  Copyright 2004 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>

//extern NSString *AMCountOfNewNodesKey;

@class DXDieGroup;
@class DXDieNode;
@class DXToolbarFactory;

@interface DXLogWindowController : NSWindowController {
	IBOutlet NSTreeController *logTreeController;
	
	NSMutableDictionary *toolbarItems;
	NSArray *AM_logSortDescriptors;
	
	IBOutlet NSOutlineView *logOutlineView;
	
	unsigned int AM_fetchedBaseNodesCount;
	
	//unsigned int AM_countOfNewNodes;
	
	BOOL AM_autoscrollEntries;
	BOOL AM_autoExpandEntries;
	
	int AM_lastMasterOrderHint;
	
	BOOL AM_processingRolls;
	
	BOOL AM_saving;
	
	//NSManagedObjectContext *logManagedObjectContext;
	NSPersistentStoreCoordinator *AM_psCoordinator;	// weak link
	
	IBOutlet DXToolbarFactory *toolbarFactory;
	//BOOL AM_isBusyWithLogEntries;
}

- (id)init;
- (void)dealloc;

- (void)windowDidLoad;
- (void)dealloc;

- (BOOL)validateMenuItem:(NSMenuItem *)menuItem;

- (void)recalculateMasterOrderHints;
- (void)logRolls:(NSArray *)rolls;
- (void)finishLoggingRoll:(NSArray *)rolls;

- (void)displayIsBusyAlert;

- (void)doubleClickedEntry:(id)sender;

@end

@interface DXLogWindowController (Export)

- (BOOL)canExportLogEntries;
- (IBAction)exportLog:(id)sender;
- (void)exportPanelDidEnd:(NSSavePanel *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo;
- (NSString *)xhtmlLogRepresentation;

@end

@interface DXLogWindowController (Fetching)

//- (BOOL)fetchLogEntries;
- (void)updateFetchedBaseNodesCount;
- (NSArray *)fetchBaseNodes;
- (unsigned int)fetchedBaseNodesCount;
- (void)setFetchedBaseNodesCount:(unsigned int)anArray;

@end


@interface NSOutlineView (DXLogAdditions)

- (void)expandFirstItem:(id)sender;
- (void)expandLastItem:(id)sender;

- (void)scrollFirstRowToVisible:(id)sender;
- (void)scrollLastRowToVisible:(id)sender;

- (void)collapseAllRows:(id)sender;
- (void)expandAllRows:(id)sender;

@end

@interface DXLogWindowController (Accessors)

- (NSArray *)logSortDescriptors;
- (void)setLogSortDescriptors:(NSArray *)anArray;

- (int)lastMasterOrderHint;
- (void)setLastMasterOrderHint:(int)anInt;

- (BOOL)isProcessingRolls;
- (void)setProcessingRolls:(BOOL)flag;

- (BOOL)isSaving;
- (void)setSaving:(BOOL)flag;

- (NSPersistentStoreCoordinator *)persistentStoreCoordinatorRef;
- (void)setPersistentStoreCoordinatorRef:(NSPersistentStoreCoordinator *)coordinator;

@end