//
//  DXToolbarFactory.h
//  DiceX
//
//  Created by Andrew Merenbach on 7/15/07.
//  Copyright 2007 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface DXToolbarFactory : NSObject {
	IBOutlet NSWindow *window;
	IBOutlet id delegate;
	
	NSMutableDictionary *toolbarItems;

	NSArray *AM_toolbarDefaultItemIdentifiers;
	NSArray *AM_toolbarAllowedItemIdentifiers;
	NSArray *AM_toolbarSelectableItemIdentifiers;
}

- (void)setupToolbarWithIdentifier:(NSString *)identifier;

/* NSToolbar delegate methods */
- (NSToolbarItem *)toolbar:(NSToolbar *)toolbar itemForItemIdentifier:(NSString *)itemIdentifier willBeInsertedIntoToolbar:(BOOL)flag;    

- (NSArray *)toolbarDefaultItemIdentifiers:(NSToolbar *)toolbar;
- (NSArray *)toolbarAllowedItemIdentifiers:(NSToolbar *)toolbar;
- (NSArray *)toolbarSelectableItemIdentifiers:(NSToolbar *)toolbar;

@end

@interface DXToolbarFactory (Accessors)

- (NSArray *)defaultItemIdentifiers;
- (void)setDefaultItemIdentifiers:(NSArray *)anArray;

- (NSArray *)allowedItemIdentifiers;
- (void)setAllowedItemIdentifiers:(NSArray *)anArray;

- (NSArray *)selectableItemIdentifiers;
- (void)setSelectableItemIdentifiers:(NSArray *)anArray;

@end