//
//  DiceX_AppDelegate.h
//  DiceX
//
//  Created by Andrew Merenbach on 27/12/06.
//  Copyright Andrew Merenbach 2006 . All rights reserved.
//

#import <Cocoa/Cocoa.h>

//extern NSString *AMSummaryKey;

@class DXLogWindowController;
@class DXAspectController;
@class DXToolbarFactory;


@interface DiceX_AppDelegate : NSObject 
{
@private

    IBOutlet NSWindow *window;
    
    NSPersistentStoreCoordinator *persistentStoreCoordinator;
    NSManagedObjectModel *managedObjectModel;
    NSManagedObjectContext *managedObjectContext;
	
	IBOutlet DXLogWindowController *logWindowController;
		
	NSMutableDictionary *aspectControllers;
	
	NSView *blankView;	// for changing window content
	
	IBOutlet NSDrawer *summaryDrawer;
	NSAttributedString *AM_summary;
	
	BOOL AM_rolling;

	id mainAspectController;
	
	IBOutlet DXToolbarFactory *toolbarFactory;
}

- (NSPersistentStoreCoordinator *)persistentStoreCoordinator;
- (NSManagedObjectModel *)managedObjectModel;
- (NSManagedObjectContext *)managedObjectContext;

- (IBAction)saveAction:sender;

//- (IBAction)startMigration:(id)sender;

- (void)loadAllValuesFromDefaults;
- (void)saveAllValuesToDefaults;

- (IBAction)launchThreadForDiceRoll:(id)sender;
- (void)roll:(id)sender;

//- (void)clearMOCIfNewVersion;
//- (void)resetInterface:(id)sender;
//- (void)resetSheetDidEnd:(NSSavePanel *)sheet returnCode:(int)returnCode;

- (void)showLogWindow:(id)sender;
- (void)toggleSummaryDrawer:(id)sender;

- (void)updateSummary:(NSNotification *)aNotification;
//- (IBAction)revertInterface:(id)sender;
//- (void)revertSheetDidEnd:(NSSavePanel *)sheet returnCode:(int)returnCode;

//- (void)prepareAspectTabView;

- (NSAttributedString *)summary;
- (void)setSummary:(NSAttributedString *)aString;

- (BOOL)isRolling;
- (void)setRolling:(BOOL)flag;

- (void)updateTitleForRollButton:(NSNotification *)aNotification;

@end

@interface DiceX_AppDelegate (RollingAlerts)

//- (void)displayAlertWithMessageText:(NSString *)messageText andInformativeText:(NSString *)informativeText;
- (void)alertCannotDropAllDice;
- (void)alertRerollingRangeErrorMinimum;
- (void)alertRerollingRangeErrorMaximum;
- (void)alertPercentileRerollingRangeErrorMinimum;
- (void)alertPercentileRerollingRangeErrorMaximum;
- (void)alertNegativeRollRepetitions;
- (void)alertNegativeValues;

@end

@interface DiceX_AppDelegate (ToolbarAspectMethods)

- (void)loadAspectMain:(id)sender;
- (void)loadAspectBasic:(id)sender;
- (void)loadAspectModifiers:(id)sender;
- (void)loadAspectRerolling:(id)sender;
- (void)loadAspectDrops:(id)sender;

- (void)loadAspectWithIdentifier:(NSString *)identifier;

@end
